// Packt alle Dateien eines Verzeichnisses rekursiv in eine einzige Datei
// Die tdbengine kann bei streams und loadtemplate auf die eingepackten Dateien zugreifen,
// wenn die Environment-Variable TDB_VDIR auf diese Datei gesetzt wird.

VAR dirs : STRING[100000,1]
VAR d_max : INTEGER
VAR data, data_ptr : INTEGER

PROCEDURE pack_file(path : STRING)
VAR b : BYTE[]; t, s, fc : INTEGER
  cgiwrite('packing: '+path+' ... ')
	t:=f_open(path,0)
  initarray(b[s:=f_size(t)])
	f_read(t,b,s)
	f_close(t)
	dirs[d_max++,0]:=exchange(path,'/','\')
        dirs[d_max,1]:=str(data_ptr)+','+str(s)
	f_seek(data,data_ptr)
	fc:=f_write(data,b,s)
	data_ptr:=data_ptr+s
	cgiwriteln('done.')
ENDPROC

PROCEDURE get_names(dir : STRING)
VAR d : STRING = firstdir(dir+'/*','D')
VAR dirs : STRING[10000]
VAR n_dirs, i : INTEGER
VAR fn : STRING
	WHILE d DO
  cgiwriteln(d)
	  fn:=rtrim(d[1,63])
	  IF d[1]<>'.' THEN
      IF pos('d',lower(d[64,7]))
			THEN dirs[n_dirs++]:=fn
			ELSE pack_file(dir+'/'+fn)
			END
		END
		d:=nextdir
	END
  WHILE i++<=n_dirs DO get_names(dir+'/'+dirs[i]) END
ENDPROC

PROCEDURE gen_data(startdir, filename : STRING)
VAR i : INTEGER[]
VAR t,j : INTEGER
  data:=f_create(filename); data_ptr:=0
  get_names(startdir)
	strsort(dirs,d_max,1,'0')
  t:=rewrite('ramtext:dir.ini')
	writeln(t,str(d_max))
	nloop(j,d_max-1,writeln(t,dirs[j+1,0]+'='+dirs[j+1,1]))
	close(t)
	copyfile('ramtext:dir.ini','dir.ini')
	pack_file('dir.ini')
	i[0]:=getsize('dir.ini');
	// delfile('dir.ini')
	f_write(data,i,4)
	f_close(data)
ENDPROC

PROCEDURE Main
  cgiclosebuffer
  gen_data('./html','html.data')
ENDPROC
